searchData={"items":[{"type":"module","title":"RTSP","doc":"Simplify connecting to RTSP servers.","ref":"RTSP.html"},{"type":"module","title":"Usage - RTSP","doc":"To start an RTSP session, you can use the `start_link/1` function with the required options:\n\n    {:ok, session} = RTSP.start_link(stream_uri: \"rtsp://localhost:554/stream\", allowed_media_types: [:video])\n    {:ok, tracks} = RTSP.connect(session)\n    :ok = RTSP.play(session)\n\nThe calling process will receive messages with the received media samples.","ref":"RTSP.html#module-usage"},{"type":"module","title":"Message Types - RTSP","doc":"The calling process will receive messages in the following format:\n\n  * `{:rtsp, pid_or_name, :discontinuity}` - Indicates a discontinuity in the stream.\n  * `{:rtsp, pid_or_name, {control_path, sample}}` - Contains the media sample received from the stream.\n    `control._path` is the RTSP control path for the track, and `sample` is the media sample data.\n  * `{:rtsp, pid_or_name, :session_closed}` - Indicates that the RTSP session has been closed.\n\nA `sample` is a tuple in the format `{payload, rtp_timestamp, key_frame?, wallclock_timestamp}`:\n  * `payload` - The media payload data (a whole access unit in case of `video`).\n  * `rtp_timestamp` - The RTP timestamp of the sample as nano second starting from 0.\n  * `key_frame?` - A boolean indicating whether the sample is a key frame (valid for `video` streams.)\n  * `wallclock_timestamp` - The wall clock timestamp when the sample was received.\n\n>","ref":"RTSP.html#module-message-types"},{"type":"module","title":"TCP and UDP - RTSP","doc":"> Currently only TCP transport is supported. UDP transport will be added in the future.","ref":"RTSP.html#module-tcp-and-udp"},{"type":"function","title":"RTSP.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"RTSP.html#child_spec/1"},{"type":"function","title":"RTSP.connect/2","doc":"Connects the rtsp server./home/ghilas/p/Evercam/ex_nvr/rtsp/lib/rtsp/source.ex\n\nIt returns the set up tracks in case of success.","ref":"RTSP.html#connect/2"},{"type":"function","title":"RTSP.play/2","doc":"Sends a play request and starts receiving media streams.","ref":"RTSP.html#play/2"},{"type":"type","title":"RTSP.session_opts/0","doc":"","ref":"RTSP.html#t:session_opts/0"},{"type":"function","title":"RTSP.start_link/1","doc":"Starts a new RTSP client session.\n\nThe following options can be provided:\n\n* `:stream_uri` - The RTSP stream URI to connect to (required).\n* `:allowed_media_types` - A list of allowed media types, defaults to: `[:video, :audio]`.\n* `:timeout` - The timeout for RTSP operations (default: `5 seconds`).\n* `:keep_alive_interval` - The interval for sending keep-alive messages (default: `30 seconds`).\n* `:parent_pid` - The parent process that will receive messages, defaults to the calling process.\n* `:name` - The name of the GenServer process, if provided it'll be used as the first element in the sent messages.","ref":"RTSP.html#start_link/1"},{"type":"function","title":"Onvif Replay - RTSP.start_link/1","doc":"To decode `onvif replay` extension packets, the following options can be provided\n\n* `:onvif_replay` - Whether to enable ONVIF replay extension (default: `false`).\n* `:start_date` - The start date for the session.\n* `:end_date` - The end date for the session.","ref":"RTSP.html#start_link/1-onvif-replay"},{"type":"function","title":"RTSP.stop/1","doc":"Closes the RTSP session and stops receiving media streams.","ref":"RTSP.html#stop/1"},{"type":"type","title":"RTSP.track/0","doc":"Represents a track in the RTSP session.\n\nEach track corresponds to a media stream and contains the following fields:\n* `control_path` - The RTSP control path for the track, can be used as an `id`.\n* `type` - The type of the media stream, which can be `:video`, `:audio`, or `:application`.\n* `fmtp` - The FMTP attribute for the track, which contains format-specific parameters.\n* `rtpmap` - The RTP mapping attribute for the track, which contains information about the payload type and encoding.","ref":"RTSP.html#t:track/0"},{"type":"module","title":"RTSP.PacketSplitter","doc":"Split the incoming network packets muxed in the same TCP connection into RTSP, RTP and RTCP packets.","ref":"RTSP.PacketSplitter.html"},{"type":"type","title":"RTSP.PacketSplitter.result/0","doc":"","ref":"RTSP.PacketSplitter.html#t:result/0"},{"type":"function","title":"RTSP.PacketSplitter.split_packets/3","doc":"Split the binary into RTSP, RTP and RTCP packets.","ref":"RTSP.PacketSplitter.html#split_packets/3"},{"type":"behaviour","title":"RTSP.RTP.Encoder","doc":"Behaviour to payload data into rtp packets.","ref":"RTSP.RTP.Encoder.html"},{"type":"callback","title":"RTSP.RTP.Encoder.handle_sample/3","doc":"Invoked to handle a new sample (e.g. access unit in case of video)","ref":"RTSP.RTP.Encoder.html#c:handle_sample/3"},{"type":"callback","title":"RTSP.RTP.Encoder.init/1","doc":"Initialize deapyloader","ref":"RTSP.RTP.Encoder.html#c:init/1"},{"type":"type","title":"RTSP.RTP.Encoder.init_opts/0","doc":"","ref":"RTSP.RTP.Encoder.html#t:init_opts/0"},{"type":"type","title":"RTSP.RTP.Encoder.rtp_timestamp/0","doc":"","ref":"RTSP.RTP.Encoder.html#t:rtp_timestamp/0"},{"type":"type","title":"RTSP.RTP.Encoder.sample/0","doc":"","ref":"RTSP.RTP.Encoder.html#t:sample/0"},{"type":"type","title":"RTSP.RTP.Encoder.state/0","doc":"","ref":"RTSP.RTP.Encoder.html#t:state/0"},{"type":"module","title":"RTSP.RTP.Encoder.H264","doc":"Payload H264 access units into RTP packets.","ref":"RTSP.RTP.Encoder.H264.html"},{"type":"module","title":"RTSP.RTP.Encoder.H265","doc":"Payload H265 access units into RTP packets.","ref":"RTSP.RTP.Encoder.H265.html"},{"type":"behaviour","title":"RTSP.RTP.Decoder","doc":"Behaviour to depayload and parse rtp packets.","ref":"RTSP.RTP.Decoder.html"},{"type":"callback","title":"RTSP.RTP.Decoder.handle_discontinuity/1","doc":"Invoked when a discontinuity occurred.\n\nA discontinuity occurs when an RTP packet is lost or missing by\nexamining the sequence numbers.","ref":"RTSP.RTP.Decoder.html#c:handle_discontinuity/1"},{"type":"callback","title":"RTSP.RTP.Decoder.handle_packet/2","doc":"Invoked when a new RTP packet is received","ref":"RTSP.RTP.Decoder.html#c:handle_packet/2"},{"type":"callback","title":"RTSP.RTP.Decoder.init/1","doc":"Initialize deapyloader","ref":"RTSP.RTP.Decoder.html#c:init/1"},{"type":"type","title":"RTSP.RTP.Decoder.rtp_timestamp/0","doc":"","ref":"RTSP.RTP.Decoder.html#t:rtp_timestamp/0"},{"type":"type","title":"RTSP.RTP.Decoder.sample/0","doc":"","ref":"RTSP.RTP.Decoder.html#t:sample/0"},{"type":"type","title":"RTSP.RTP.Decoder.state/0","doc":"","ref":"RTSP.RTP.Decoder.html#t:state/0"},{"type":"module","title":"RTSP.RTP.Decoder.H264","doc":"Parse H264 NAL units","ref":"RTSP.RTP.Decoder.H264.html"},{"type":"module","title":"RTSP.RTP.Decoder.H265","doc":"Parse and assemble H265 NAL units into access units.","ref":"RTSP.RTP.Decoder.H265.html"},{"type":"module","title":"RTSP.RTP.OnvifReplayExtension","doc":"A module describing onvif replay rtp header extension","ref":"RTSP.RTP.OnvifReplayExtension.html"},{"type":"function","title":"RTSP.RTP.OnvifReplayExtension.decode/1","doc":"Decodes the rtp onvif extension header.","ref":"RTSP.RTP.OnvifReplayExtension.html#decode/1"},{"type":"type","title":"RTSP.RTP.OnvifReplayExtension.t/0","doc":"","ref":"RTSP.RTP.OnvifReplayExtension.html#t:t/0"},{"type":"extras","title":"RTSP","doc":"# RTSP\n\n[![Hex.pm](https://img.shields.io/hexpm/v/rtsp.svg)](https://hex.pm/packages/rtsp)\n[![API Docs](https://img.shields.io/badge/api-docs-yellow.svg?style=flat)](https://hexdocs.pm/rtsp)\n\nSimplify connecting to RTSP servers.","ref":"readme.html"},{"type":"extras","title":"Usage - RTSP","doc":"Start the client, connect and start receiving media\n\n```elixir\n{:ok, session} = RTSP.start_link(stream_uri: \"rtsp://localhost:554/stream\", allowed_media_types: [:video])\n{:ok, tracks} = RTSP.connect(session)\n:ok = RTSP.play(session)\n```\n\nThe current process will receive media stream:\n```elixir\n{pid_or_name, control_path, {sample, rtp_timestamp, timestamp, key_frame?}}\n```","ref":"readme.html#usage"},{"type":"extras","title":"Installation - RTSP","doc":"The package can be installed by adding `rtsp` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:rtsp, \"~> 0.2.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   APPENDIX: How to apply the Apache License to your work.\n\n      To apply the Apache License to your work, attach the following\n      boilerplate notice, with the fields enclosed by brackets \"[]\"\n      replaced with your own identifying information. (Don't include\n      the brackets!)  The text should be enclosed in the appropriate\n      comment syntax for the file format. We also recommend that a\n      file or class name and description of purpose be included on the\n      same \"printed page\" as the copyright notice for easier\n      identification within third-party archives.\n\n   Copyright 2018 Software Mansion\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}